module FFMPEG
  class Stream
    attr_reader :input_number, :stream_number, :language, :type
    attr_reader :video_codec, :video_bitrate, :colorspace, :resolution, :dar
    attr_reader :audio_channels, :audio_codec, :audio_bitrate, :audio_sample_rate
    attr_reader :subtitle_codec, :subtitle_format

    private

      attr_writer :input_number, :stream_number, :language, :type
      attr_writer :video_codec, :video_bitrate, :colorspace, :resolution, :dar
      attr_writer :audio_codec, :audio_bitrate, :audio_sample_rate
      attr_writer :subtitle_codec, :subtitle_format

      def audio_channels=(value)
        if value.strip =~ /^(\d+)\.(\d+)(?:\(.*?\))?$/
          @audio_channels = [$1.to_i + $2.to_i, 6].min
        elsif value.strip =~ /stereo/i
          @audio_channels = 2
        elsif value.strip =~ /mono/i
          @audio_channels = 1
        else
          @audio_channels = value
        end
      end
  end
end